<!DOCTYPE html>
<html class="writer-html5" lang="en" data-content_root="./">
<head>
  <meta charset="utf-8" /><meta name="viewport" content="width=device-width, initial-scale=1" />

  <meta name="viewport" content="width=device-width, initial-scale=1.0" />
  <title>5. ROS2 node in simulation and reality &mdash; Spade 1.0 documentation</title>
      <link rel="stylesheet" type="text/css" href="_static/pygments.css?v=80d5e7a1" />
      <link rel="stylesheet" type="text/css" href="_static/css/theme.css?v=19f00094" />
      <link rel="stylesheet" type="text/css" href="_static/copybutton.css?v=76b2166b" />
      <link rel="stylesheet" type="text/css" href="_static/tabs.css?v=a5c4661c" />

  
    <link rel="shortcut icon" href="_static/Spade_icon_2.ico"/>
  <!--[if lt IE 9]>
    <script src="_static/js/html5shiv.min.js"></script>
  <![endif]-->
  
        <script src="_static/jquery.js?v=5d32c60e"></script>
        <script src="_static/_sphinx_javascript_frameworks_compat.js?v=2cd50e6c"></script>
        <script src="_static/documentation_options.js?v=f2a433a1"></script>
        <script src="_static/doctools.js?v=9a2dae69"></script>
        <script src="_static/sphinx_highlight.js?v=dc90522c"></script>
        <script src="_static/clipboard.min.js?v=a7894cd8"></script>
        <script src="_static/copybutton.js?v=f281be69"></script>
    <script src="_static/js/theme.js"></script>
    <link rel="index" title="Index" href="genindex.html" />
    <link rel="search" title="Search" href="search.html" />
    <link rel="prev" title="4. Interacting with the Raspberry Pi" href="RaspberryPi.html" /> 
</head>

<body class="wy-body-for-nav"> 
  <div class="wy-grid-for-nav">
    <nav data-toggle="wy-nav-shift" class="wy-nav-side">
      <div class="wy-side-scroll">
        <div class="wy-side-nav-search" >

          
          
          <a href="index.html" class="icon icon-home">
            Spade
              <img src="_static/Spade_icon_2.png" class="logo" alt="Logo"/>
          </a>
<div role="search">
  <form id="rtd-search-form" class="wy-form" action="search.html" method="get">
    <input type="text" name="q" placeholder="Search docs" aria-label="Search docs" />
    <input type="hidden" name="check_keywords" value="yes" />
    <input type="hidden" name="area" value="default" />
  </form>
</div>
        </div><div class="wy-menu wy-menu-vertical" data-spy="affix" role="navigation" aria-label="Navigation menu">
              <p class="caption" role="heading"><span class="caption-text">Contents:</span></p>
<ul class="current">
<li class="toctree-l1"><a class="reference internal" href="Hardware.html">1. Hardware components</a></li>
<li class="toctree-l1"><a class="reference internal" href="Battery.html">2. Charging the battery</a></li>
<li class="toctree-l1"><a class="reference internal" href="Flying.html">3. Flying</a></li>
<li class="toctree-l1"><a class="reference internal" href="RaspberryPi.html">4. Interacting with the Raspberry Pi</a></li>
<li class="toctree-l1 current"><a class="current reference internal" href="#">5. ROS2 node in simulation and reality</a><ul>
<li class="toctree-l2"><a class="reference internal" href="#id1">5.1. Simulation</a></li>
<li class="toctree-l2"><a class="reference internal" href="#real-world">5.2. Real-world</a></li>
</ul>
</li>
</ul>

        </div>
      </div>
    </nav>

    <section data-toggle="wy-nav-shift" class="wy-nav-content-wrap"><nav class="wy-nav-top" aria-label="Mobile navigation menu" >
          <i data-toggle="wy-nav-top" class="fa fa-bars"></i>
          <a href="index.html">Spade</a>
      </nav>

      <div class="wy-nav-content">
        <div class="rst-content">
          <div role="navigation" aria-label="Page navigation">
  <ul class="wy-breadcrumbs">
      <li><a href="index.html" class="icon icon-home" aria-label="Home"></a></li>
      <li class="breadcrumb-item active"><span class="section-number">5. </span>ROS2 node in simulation and reality</li>
      <li class="wy-breadcrumbs-aside">
            <a href="_sources/Simulation.rst.txt" rel="nofollow"> View page source</a>
      </li>
  </ul>
  <hr/>
</div>
          <div role="main" class="document" itemscope="itemscope" itemtype="http://schema.org/Article">
           <div itemprop="articleBody">
             
  <div class="toctree-wrapper compound">
</div>
<section id="ros2-node-in-simulation-and-reality">
<span id="simulation"></span><h1><span class="section-number">5. </span>ROS2 node in simulation and reality<a class="headerlink" href="#ros2-node-in-simulation-and-reality" title="Link to this heading"></a></h1>
<p>In this section, we will take a look at trying to run a simple ROS2 node both in simulation and on your actual drone.
.. note:: Be aware that this is not a ROS2 tutorial, if you want to learn more about using ROS2 please refer to their <a class="reference external" href="https://docs.ros.org/en/humble/index.html">guide</a></p>
<section id="id1">
<h2><span class="section-number">5.1. </span>Simulation<a class="headerlink" href="#id1" title="Link to this heading"></a></h2>
<p>To set up ROS2 with your PX4 flight controller and get started with simulation, please refer to this <a class="reference external" href="https://docs.px4.io/main/en/ros/ros2_comm.html">guide</a> and follow it at least until reaching the examples. When downloading the PX4 software, we strongly recommend, that you download one of their releases from their GitHub. Otherwise, you are at risk of encountering new bugs.</p>
<p>After completing their guide, you can then download our ROS2node from <a class="reference external" href="https://github.com/Markus-Simonsen/Spade_docs/">here</a> and run it in your ROS2 environment.</p>
</section>
<section id="real-world">
<h2><span class="section-number">5.2. </span>Real-world<a class="headerlink" href="#real-world" title="Link to this heading"></a></h2>
<p>To run the ROS2 node on your actual drone the first step is to enter QGroundControl then go to Analyze Tools then MAVLink Console and type <cite>ver all</cite>. Under the tag “HW type:” you should now see the board name of the drone. Going into the PX4 directory that you downloaded in the previous section find the following file: PX4-autopilot/src/modules/uxrce_dds_client/dds_topics.yaml. Here you can then see all of the topics that the flight controller will publish, and uncomment the ones that you will need.</p>
<p>Before trying to compile the code please check that you have the right compiler installed by running the command below.</p>
<p>Next, run the following file and command from the root of your PX4-Autopilot directory. Make sure to replace &lt;board-model&gt; with your board model.</p>
<div class="highlight-console notranslate"><div class="highlight"><pre><span></span><span class="go">Tools/setup/ubuntu.sh</span>
<span class="go">make &lt;board-model&gt;</span>
</pre></div>
</div>
<p>Now just flash your PX4 firmware through QGroundControl and your flight controller is ready. When you arm your drone and switch over to offboard flight mode, your drone should start executing the flight specified in the ROS node. At this point you should be ready to modify the ROS node and begin making your programs to execute pre-determined flights</p>
</section>
</section>


           </div>
          </div>
          <footer><div class="rst-footer-buttons" role="navigation" aria-label="Footer">
        <a href="RaspberryPi.html" class="btn btn-neutral float-left" title="4. Interacting with the Raspberry Pi" accesskey="p" rel="prev"><span class="fa fa-arrow-circle-left" aria-hidden="true"></span> Previous</a>
    </div>

  <hr/>

  <div role="contentinfo">
    <p>&#169; Copyright 2024, Markus Simonsen.</p>
  </div>

  Built with <a href="https://www.sphinx-doc.org/">Sphinx</a> using a
    <a href="https://github.com/readthedocs/sphinx_rtd_theme">theme</a>
    provided by <a href="https://readthedocs.org">Read the Docs</a>.
   

</footer>
        </div>
      </div>
    </section>
  </div>
  <script>
      jQuery(function () {
          SphinxRtdTheme.Navigation.enable(true);
      });
  </script> 

</body>
</html>